function displayDetailDivFS(source,id) {
    if (id == "_motscles") {
        var name = source.name;
        var suffix = name.substring(name.lastIndexOf("_") + 1);
        id = "FS_thesaurusList_" + suffix;
        checkPiocheur(source, suffix);
    }
    else {
        id = "FS_" + id;
    }
    var displayBlock = document.getElementById(id);
    var display = source.checked;
    if (source.value == "1") display = !display;
    var newDisplay;
    if (display) {
        newDisplay="block";
    }
    else {
        newDisplay="none";
    }
    displayBlock.style.display= newDisplay;
}

function checkPiocheur(source, suffix) {
    var all = source.checked;
    if (source.value != "1") all = !all;
    if (all) {
        updatePiocheur(suffix,"");
    }
    else {
        var subsets = getSubsets(suffix);
        updatePiocheur(suffix,subsets);
    }
}

function checkPiocheurSelection(source) {
    var name = source.name;
    var suffix = name.substring(name.lastIndexOf("_") + 1);
    var subsets = getSubsets(suffix);
    if (subsets == "_null") {
        alert(global_err_motcle_selection);
    }
    updatePiocheur(suffix, subsets);
}

function updatePiocheur(suffix, subsets) {
    var piocheur = document.getElementById("FS_motclePiocheur_" + suffix);
    var href = piocheur.href;
    var idx1 = href.indexOf(",",href.indexOf(",") + 1) +2;
    var href1 = href.substring(0, idx1);
    var idx2 = href.indexOf("'",idx1);
    var href2 = href.substring(idx2);
    piocheur.href= href1 + subsets + href2;
    var image = piocheur.getElementsByTagName("img")[0];
    if (subsets.length == 0) {
        image.title= global_link_pioche_motcle_all;
    }
    else {
        image.title = global_link_pioche_motcle_selection;
    }
}

function getSubsets(suffix) {
    var motcleSelection = document.getElementsByName("motcle_selection_" + suffix);
    var subsets = "";
    for(var i = 0; i < motcleSelection.length;i++) {
        var element = motcleSelection[i];
        if (element.options != null) {
            for(var j = 0; j < element.options.length;j++) {
                var option = element.options[j];
                if (option.selected) {
                    subsets = subsets + option.value + ",";
                }
            }
        }
        else {
            if (element.checked) {
                subsets = subsets + element.value + ",";
            }
        }
    }
    if (subsets.length == 0) {
        return "_null";
    }
    else {
        return subsets.substring(0, subsets.length - 1);
    }
}

function displayThesaurusSelect(suffix) {
    var elLink = document.getElementById("FS_thesaurusSelectLink_" + suffix);
    var elSelect = document.getElementById("FS_thesaurusSelect_" + suffix);
    elLink.style.display="none";
    elSelect.style.display="block";
}

function addNewSelection() {
    var elMode = document.getElementById("FS_motsclesMode");
    elMode.style.display="block";

    var elDiv = document.getElementById("FS_motsclesFieldSets");
    var array = elDiv.getElementsByTagName("fieldset");
    var copySelect;
    var suffixMax = 0;
    for(var i = 0; i < array.length;i++) {
        var id = array[i].id;
        var idx = id.lastIndexOf("_");
        var suffix = id.substring(idx+1);
        if (suffix == "nnn") {
            copySelect = array[i];
        }
        else {
            suffixMax = Math.max(suffixMax,suffix);
        }
    }
    var clone = copySelect.cloneNode(true);
    suffix = suffixMax + 1;
    replaceLegend(clone,suffix);
    replaceInElement(clone,suffix);
    clone.style.display="block";
    elDiv.insertBefore(clone,copySelect);
}

function replaceLegend(clone,suffix) {
    var legend = clone.getElementsByTagName("legend")[0];
    var legendText = legend.firstChild.data;
    legend.firstChild.data = replaceString(legendText,suffix);
}

function replaceInElement(el,suffix) {
    var id = el.id;
    if (id != undefined) {
        el.id = replaceString(id,suffix);
    }
    var name = el.name;
    if (name != undefined) {
        el.name = replaceString(name,suffix);
    }
    var href = el.href;
    if (href != undefined) {
        el.href = replaceString(href,suffix);
    }
    var children = el.childNodes;
    for(var i = 0; i < children.length;i++) {
        var node = children[i];
        if (node.nodeType == 1) {
            replaceInElement(node,suffix);
        }
    }
}


function replaceString(s, suffix) {
    return s.replace("nnn",suffix);
}

function piocheMotcle(category,appelant,subsets,limite,path, param) {
    var suffix = appelant.substring(appelant.lastIndexOf("_") + 1);
    var elcheck = document.getElementById("motcle_all_" + suffix);
    if (subsets == "_null") {
        alert(global_err_motcle_selection);
        return;
    }
    var url = path + "Pioche?category=" + category + "&subsets=" + subsets + "&appelant=" + appelant + "&limite=" + limite;
    if (param != null) {
        url = url + "&param=" + param;
    }
    var w = window.open(url,"pioche_"+appelant,"resizable=yes,width=430,height=510");
    w.focus();
}