var POS_PRV_CARTE = null;
var POS_PRV_PAN_COUNT = 0;
var POS_PRV_NOUVEAU = false;
var POS_PRV_NOUVEAU_LAT = -999;
var POS_PRV_NOUVEAU_LON = -999;
var POS_PRV_NOUVEAU_MARQUEUR = null;
var POS_PRV_ACTUEL_MARQUEUR = null;
var POS_PRV_ZOOMLEVEL_DEFAULT = 17;

function POS_InitCarte() {
    POS_PRV_CARTE = new YMap(document.getElementById('POS_ID_CARTE'));
    POS_PRV_CARTE.setMapType(YAHOO_MAP_REG);
    POS_PRV_CARTE.addZoomLong();
    POS_PRV_CARTE.addPanControl();
    YEvent.Capture(POS_PRV_CARTE, EventsList.onEndGeoCode, finPOS_Geocodage);
    function finPOS_Geocodage() {
        var currentGeoPoint = POS_PRV_CARTE.getCenterLatLon();
        var curLat = currentGeoPoint.Lat;
        var curLon = currentGeoPoint.Lon;
        if ((curLat != 0) || (curLon != 0)) {
            POS_SetNouveau(curLat, curLon);
        }
        else {
            POS_PRV_CARTE.setZoomLevel(POS_PRV_ZOOMLEVEL_DEFAULT);
            if (window.POS_FUNCTION_ADRESSENONLOCALISABLE) {
                POS_FUNCTION_ADRESSENONLOCALISABLE();
            }
        }
    }
    YEvent.Capture(POS_PRV_CARTE, EventsList.MouseDown, departClick);
    function departClick(_e, _c){
        POS_PRV_PAN_COUNT = 0;
    }
    YEvent.Capture(POS_PRV_CARTE, EventsList.onPan, glissementPendantClick);
    function glissementPendantClick() {
        POS_PRV_PAN_COUNT = POS_PRV_PAN_COUNT+1;
    }
    YEvent.Capture(POS_PRV_CARTE, EventsList.MouseUp, finClick);
    function finClick(_e, _c){
        if (POS_PRV_PAN_COUNT < 5) {
            POS_SetNouveau( _c.Lat, _c.Lon );
        }
        else {
		
        }
        POS_PRV_PAN_COUNT = 0;
    }
	
    if ((POS_PUB_ACTUEL_LAT > - 999) && (POS_PUB_ACTUEL_LON > -999)) {
        var centreGeoPoint = new YGeoPoint(POS_PUB_ACTUEL_LAT, POS_PUB_ACTUEL_LON);
        POS_PRV_CARTE.drawZoomAndCenter(centreGeoPoint, POS_PUB_ZOOM);
        POS_PRV_ACTUEL_MARQUEUR = POS_AddMarqueur("actuel",centreGeoPoint,POS_PUB_ACTUEL_TITRE);
    }
    else {
        POS_PRV_CARTE.drawZoomAndCenter(new YGeoPoint(0,0), POS_PRV_ZOOMLEVEL_DEFAULT);
    }
    POS_Check();
}

function POS_SetNouveau(latitude, longitude) {
    var currentGeoPoint = new YGeoPoint(latitude, longitude);
    if (!POS_TestGeoPoint(currentGeoPoint)) return;
    if (!POS_PRV_NOUVEAU) {
        POS_PRV_NOUVEAU = true;
        POS_PRV_NOUVEAU_MARQUEUR = POS_AddMarqueur("nouveau", currentGeoPoint, POS_PUB_NOUVEAU_TITRE);
    }
    else {
        POS_PRV_NOUVEAU_MARQUEUR.setYGeoPoint(currentGeoPoint);
    }
    POS_PRV_NOUVEAU_LAT = latitude;
    POS_PRV_NOUVEAU_LON = longitude;
    POS_Check();
}

function POS_AddMarqueur(iconType, geoPoint, titre) {
    var marqueur = new YMarker(geoPoint, POS_GetImageInstance(iconType));
    marqueur.addAutoExpand(titre);
    POS_PRV_CARTE.addOverlay(marqueur);
    return marqueur;
}

function POS_TestGeoPoint(geoPoint) {
    if ((geoPoint.Lon == -180)) {
        return false;
    }
    return true;
}


function POS_Geocodage() {
    if (!window.POS_FUNCTION_GET_ADRESSE) return false;
    var adresse = POS_CleanString(POS_FUNCTION_GET_ADRESSE());
    if (adresse.length > 0) {
        adresse = POS_AccentToNoAccent(adresse);
        POS_PRV_CARTE.drawZoomAndCenter(adresse, POS_PUB_ZOOM);
        return true;
    }
    else {
        return false;
    }
}

function POS_CentrerSur(iconType) {
    if (iconType == "actuel") {
        POS_CentrerSurMarqueur(POS_PRV_ACTUEL_MARQUEUR);
    }
    else if (iconType == "nouveau") {
        POS_CentrerSurMarqueur(POS_PRV_NOUVEAU_MARQUEUR);
    }
}

function POS_CentrerSurMarqueur(marqueur) {
    if (marqueur != null) {
        POS_PRV_CARTE.drawZoomAndCenter(marqueur.YGeoPoint, POS_PRV_CARTE.getZoomLevel());
    }
}

function POS_CentrerSurDeux() {
    if ((POS_PRV_ACTUEL_MARQUEUR == null) || (POS_PRV_NOUVEAU_MARQUEUR == null)) return;
    var array = new Array();
    array[0] = POS_PRV_ACTUEL_MARQUEUR.YGeoPoint;
    array[1] = POS_PRV_NOUVEAU_MARQUEUR.YGeoPoint;
    var obj = POS_PRV_CARTE.getBestZoomAndCenter(array);
    var zoomLevel = obj.zoomLevel;
    if (zoomLevel < 16) zoomLevel = zoomLevel + 1;
    POS_PRV_CARTE.drawZoomAndCenter(obj.YGeoPoint, zoomLevel);
}

function POS_Check() {
    var actuelActif = (POS_PRV_ACTUEL_MARQUEUR != null);
    var nouveauActif = (POS_PRV_NOUVEAU_MARQUEUR != null);
    if (window.POS_FONCTION_CHECK) {
        POS_FONCTION_CHECK(actuelActif, nouveauActif);
    }
}


function POS_GetImageInstance(iconType){
    if (iconType == "actuel") {
        return POS_PUB_ACTUEL_MARQUEURIMAGE.toYImage();
    }
    else if (iconType == "nouveau") {
        return POS_PUB_NOUVEAU_MARQUEURIMAGE.toYImage();
    }
}

function POS_CleanString(val) {
    val =val.replace(/[\n\t]/g," ");
    val = val.replace(/^\s+|\s+$/g,"");
    val = val.replace(/\s+/g, " ");
    return val;
}

function POS_GetNouveauLat() {
    return POS_PRV_NOUVEAU_LAT;
}

function POS_GetNouveauLon() {
    return POS_PRV_NOUVEAU_LON;
}


// Remplace toutes les occurences d'une chaine
function POS_replaceAll(str, search, repl) {
    while (str.indexOf(search) != -1)
        str = str.replace(search, repl);
    return str;
}

// Remplace les caractères accentués
function POS_AccentToNoAccent(str) {
    var norm = new Array('À','Á','Â','Ã','Ä','Å','Æ','Ç','È','É','Ê','Ë','Ì','Í','Î','Ï', 'Ð','Ñ','Ò','Ó','Ô','Õ','Ö','Ø','Ù','Ú','Û','Ü','Ý','Þ','ß', 'à','á','â','ã','ä','å','æ','ç','è','é','ê','ë','ì','í','î','ï','ð','ñ', 'ò','ó','ô','õ','ö','ø','ù','ú','û','ü','ý','ý','þ','ÿ','Œ','œ');
    var spec = new Array('A','A','A','A','A','A','AE','C','E','E','E','E','I','I','I','I', 'D','N','O','O','O','0','O','O','U','U','U','U','Y','b','s', 'a','a','a','a','a','a','ae','c','e','e','e','e','i','i','i','i','d','n', 'o','o','o','o','o','o','u','u','u','u','y','y','b','y','OE','oe');
    for (var i = 0; i < spec.length; i++)
        str = POS_replaceAll(str, norm[i], spec[i]);
    return str;
}