function PCH_Recherche () {

}

PCH_Recherche.data = null;

PCH_Recherche.init = function () {
    PCH_Core.setOkEnabled (false);
    var formEl = $("form");
    PCH_Utils.appendDataType(formEl, "json");
    var total = PCH_Core.getTotal();
    $("#ID_PIOCHE_PROP_SELECT").click(PCH_Recherche.selection);
    $("#ID_PIOCHE_SEL_SELECT").click(PCH_Recherche.deselection);
    $("#ID_PIOCHE_OK").click(PCH_Recherche.validation);
    $("#ID_PIOCHE_CANCEL").click(PCH_Core.annulation);
    if (PCH_Core.getLimite() == 1) {
        $("#ID_PIOCHE_SEL_SELECT").attr("size", "2");
    }
    if ((total > -1) && (total < 31)) {
        $("#ID_PIOCHE_FORMDIV").addClass("jq_PCH_Inactif");
        formEl.ajaxSubmit({
            dataType:  'json',
            success:   PCH_Recherche.processJson
        });
    } else {
        formEl.ajaxForm({
            dataType:  'json',
            success:   PCH_Recherche.processJson
        });
        $("#ID_PIOCHE_FORMDIV input[name='recherche']").get(0).focus();
    }
}

PCH_Recherche.processJson = function (data) {
    PCH_Recherche.data = data;
    var length = data.length;
    $("#ID_PIOCHE_PROP_TOTAL").text(length);
    var ongletsJqEl = $("#ID_PIOCHE_PROP_ONGLETS");
    ongletsJqEl.empty();
    if (length == 0) {
        alert(PCH_Core.getLoc("pioche_info_aucunresultat"));
    } else {
        var seuilvisibilite = Math.ceil(length/10);
        if (seuilvisibilite > 1) {
            for (var k = 0; k < seuilvisibilite;k++) {
                PCH_Recherche.appendOnglet(ongletsJqEl, k);
            }
            PCH_Recherche.activeOnglet(0);
        } else {
            PCH_Recherche.affichePropositions(0);
        }
    }

}

PCH_Recherche.appendOnglet = function (ongletsJqEl, dizaine) {
    var diz2 = dizaine + 1;
    $("<span></span>").appendTo(ongletsJqEl).attr("id","jqid_onglet_" + dizaine).addClass("jq_PCH_Onglet").click(PCH_Recherche.clicOnglet).text(" - " + diz2);
}

PCH_Recherche.clicOnglet = function () {
    var dizaine = this.id.substring("jqid_onglet_".length);
    PCH_Recherche.activeOnglet(dizaine);
}

PCH_Recherche.activeOnglet = function (dizaine) {
    var ongletJqEl = $("#jqid_onglet_" + dizaine);
    if (ongletJqEl.hasClass("jq_PCH_OngletActif")) {
        return;
    }
    $("span.jq_PCH_OngletActif").removeClass("jq_PCH_OngletActif").addClass("jq_PCH_Onglet");
    ongletJqEl.removeClass("jq_PCH_Onglet").addClass("jq_PCH_OngletActif");
    PCH_Recherche.affichePropositions(dizaine);
}

PCH_Recherche.affichePropositions = function (dizaine) {
    var propSelectJqEl = $("#ID_PIOCHE_PROP_SELECT");
    propSelectJqEl.empty();
    var plafond = Math.min(PCH_Recherche.data.length, 10*(dizaine + 1));
    var plancher = 10*dizaine;
    var wanted = PCH_Core.getWanted();
    for (var k = plancher; k < plafond;k ++) {
        var object = PCH_Recherche.data.array[k];
        var key = "";
        var text = "";
        if (wanted == "intkey") {
            key = object.intkey;
        } else {
            if (object.idalphakey) {
                key = "idalphakey:" + object.idalphakey;
            } else {
                key = "intkey:" + object.intkey;
            }
        }
        if (object.idalphakey) {
            text = object.idalphakey + PCH_Core.getSeparator();
            if (object.text) {
                text = text + object.text;
            }
        } else {
            if (object.text) {
                text = text + object.text;
                if (wanted == "idalphakey_intkey") {
                    text = text + " (id=" + object.intkey + ")";
                }
            } else {
                text = object.intkey;
            }
        }
        $("<option></option>").appendTo(propSelectJqEl).attr("value", key).text(text);
    }
}

PCH_Recherche.selection = function () {
    var idx = this.selectedIndex;
    if (idx == -1) return;
    var option = this.options[idx];
    var valeur = option.value;
    var selJqEl = $("#ID_PIOCHE_SEL_SELECT");
    var options = selJqEl[0].options;
    for (var i = 0; i < options.length;  i++) {
        if (options[i].value == valeur) return;
    }
    $("<option></option>").appendTo(selJqEl).attr("value", valeur).text(option.text);
    PCH_Recherche.checkSelect();
    $("#ID_PIOCHE_OK")[0].focus();
}

PCH_Recherche.checkSelect = function () {
    var selJqEl = $("#ID_PIOCHE_SEL_SELECT");
    var count = selJqEl.find("option").length;
    var limite = PCH_Core.getLimite();
    if((limite != -1) && (count >= limite)) {
        $("#ID_PIOCHE_FORMDIV").addClass("jq_PCH_Invisible");
        $("#ID_PIOCHE_PROP_SELECT").attr("disabled","true");
    }
    else {
        $("#ID_PIOCHE_FORMDIV").removeClass("jq_PCH_Invisible");
        $("#ID_PIOCHE_PROP_SELECT").removeAttr("disabled");
    }
    PCH_Core.setOkEnabled((count != 0));
    $("#ID_PIOCHE_SEL_TOTAL").text(count);
}

PCH_Recherche.deselection = function () {
    var idx = this.selectedIndex;
    if (idx == -1) return;
    this.remove(idx);
    this.selectedIndex = -1;
    PCH_Recherche.checkSelect();
}

PCH_Recherche.validation = function () {
    this.disabled = true;
    var limite = PCH_Core.getLimite();
    var selJqEl = $("#ID_PIOCHE_SEL_SELECT option");
    var texte = "";
    var length = selJqEl.length;
    var wanted = PCH_Core.getWanted();
    for (var i = 0; i < length;i++) {
        var option = selJqEl.get(i);
        var value = "";
        if (wanted == "intkey") {
            value = option.value;
        } else {
            value = option.value;
            if (value.indexOf("idalphakey:") == 0) {
                value = value.substring("idalphakey:".length);
            } else {
                if (wanted == "idalphakey_text") {
                    value = option.text;
                } else {
                    value = value.substring("intkey:".length);
                }
            }
        }
        texte = texte + value;
        if (limite != 1) texte = texte + "; ";
    }
    var element = window.opener.document.getElementById(PCH_Core.getAppelantId());
    if (limite != 1) {
        var currentTexte = element.value;
        if (PCH_Utils.testPointVirgule(currentTexte)) {
            currentTexte = currentTexte + "; ";
        }
        texte = currentTexte + texte;
    }
    element.value = texte;
    window.close();
}

$(function () {
    PCH_Recherche.init();
});